# Conclusion (B,HK)

Knime is a tool to build graphical workflow with a focus on data analysis. It could be helpful for a team offering data analysis service by increasing the reusability of developed pipeline and facilitating their development. In particular, it provides tools for image analysis and allows integrating popular image processing libraries.

In practice, building a pipeline is quite intuitive with standard node's I/O, clear node name and complete (easy to access by search) documentation. Individual nodes interface is quite impressive at first the sight and needs some adaptation periods of time. However, running a node usually does not require to master all of its interface. Once a workflow is built, the batch processing is there for free, and multi-threading can be added with little effort (and various flavours). Cluster processing, however, is a feature we have not explored enough in practice. This feature documentation will be added in the next report.

Another nice infrastructure feature is the reporting system that can be automatized providing list of results, summaries and graphs. Result exploration is also possible with some viewing capable nodes. Tabular result data is summarized by KNIME Report framework, as forms of summary table and various charts. For images, the viewer while not being as versatile and easy to use as an ImageJ UI provides necessary functionality for any image dimension at no cost. Overlaying 3D ROI(Region-Of-Interest) to 3D image is part of these features for instance.

Also Knime workflows provide a centralized place to run complex and heterogeneous (relying on different languages) analysis in one click. Pipeline can also be easily duplicated and saved with their settings for a specific project. To deploy a pipeline on a user machine, it would however still need to install dependencies manually (Python, Matlab, R server) if they are not there yet. Nodes distribution can potentially be done via an update site mechanism as centralized deployment approach is necessary for the service facilitation.

Finally image analysis node collection (Knip) provides many well documented nodes and also unique functionalities. However, it is really like learning a new library to get started with the nodes. The integration of ImageJ could simplify that however the current integration, still in beta, is still limited. Writing a new node requires to develop in Java and IJ node I/O are still limited. Ideally one would write an annotated script in ImageJ and to use it as a node afterward in Knime. A complete rewrite of IJ integration is now on the work and could be available to test at Fall. Development wise Knip relies on Imglib2 and SciJava which are also at the core of ImageJ.

In the end, Knime seems well suited for systematic / well-established task rather. Quick prototyping would be possible with sufficient experience of the framework. Beside our simple example it would be interesting to implement a real life pipeline and see if it could actually be proposed as a service. The [TGMM pipeline](http://www.nature.com/nprot/journal/v10/n11/abs/nprot.2015.111.html) for cell detection and tracking could be used for this pilot project providing some reporting and bringing some additional parameter control. Additionally, following up on cluster processing, @parameter annotation and IJ new integration (scripts) in Knime would be of interest. 

Note: [Knime 3.2 is out (2016-07-08)](https://tech.knime.org/whats-new-in-knime-32)
