
## Parallelization (HK)

Reference: [Parallel and distributed data pipelining with knime](http://kops.uni-konstanz.de/bitstream/handle/123456789/5542/Parallel_and_Distributed_Data_Pipelining_with_KNIME.pdf?sequence=1)

There are several ways to parallelize a KNIME workflow. The most simple one is the parallel execution of different branches in the workflow which is processed independently. Each node that is ready for execution can run in its own thread managed by KNIME workflow manager. The more advanced way is to process the data rows of the input table in parallel. The most sophisticated way of parallelization is to execute whole sub-workflows in a distributed way. Not many algorithms allow for parallelization whenever they have pipeline dependencies. 

* Threaded parallelization is controlled by KNIME workflow manager: it keeps track of queuing and executing the nodes in a workflow.
* Distributed execution needs to consider a job submission queue plan and management based on the scheduled states where master/worker approach is used.

The below figure shows how to parallelize the conventional pipeline because each image can be divided by [_Parallel Chunk Start_](https://www.knime.org/files/nodedetails/_labs_parallelexec_Parallel_Chunk_Start.html), processed by _Gaussian Convolution_, _Global Thresholder_ and _Connected Components Analysis_, and the result is merged in [_Parallel Chunk End_](https://www.knime.org/files/nodedetails/_labs_parallelexec_Parallel_Chunk_End.html).

